Index: java/net/deterlab/abac/ABACException.java
===================================================================
--- java/net/deterlab/abac/ABACException.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/ABACException.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -6,5 +6,5 @@
  * possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class ABACException extends Exception  {
Index: java/net/deterlab/abac/BadSignatureException.java
===================================================================
--- java/net/deterlab/abac/BadSignatureException.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/BadSignatureException.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -5,5 +5,5 @@
  * include a cause from the underlying library that caused them when possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class BadSignatureException extends ABACException  {
Index: java/net/deterlab/abac/CertInvalidException.java
===================================================================
--- java/net/deterlab/abac/CertInvalidException.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/CertInvalidException.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -7,5 +7,5 @@
  * library that caused them when possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class CertInvalidException extends ABACException  {
Index: java/net/deterlab/abac/Context.java
===================================================================
--- java/net/deterlab/abac/Context.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/Context.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -22,5 +22,5 @@
  * proof.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class Context {
@@ -82,5 +82,5 @@
      * or total proof, and success indicates whether the proof succeeded.
      * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
-     * @version 1.3
+     * @version 1.4
      */
     public class QueryResult {
Index: java/net/deterlab/abac/Credential.java
===================================================================
--- java/net/deterlab/abac/Credential.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/Credential.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -21,5 +21,5 @@
  * their constituent Roles.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public abstract class Credential implements Comparable {
Index: java/net/deterlab/abac/CredentialFactory.java
===================================================================
--- java/net/deterlab/abac/CredentialFactory.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/CredentialFactory.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -12,5 +12,5 @@
  * credential parsing should use a credential factory.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class CredentialFactory implements Cloneable {
Index: java/net/deterlab/abac/CredentialParser.java
===================================================================
--- java/net/deterlab/abac/CredentialParser.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/CredentialParser.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -12,5 +12,5 @@
  * constructor.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public abstract class CredentialParser {
Index: java/net/deterlab/abac/GENICredential.java
===================================================================
--- java/net/deterlab/abac/GENICredential.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/GENICredential.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -36,5 +36,5 @@
  * their constituent Roles.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class GENICredential extends Credential implements Comparable {
Index: java/net/deterlab/abac/Identity.java
===================================================================
--- java/net/deterlab/abac/Identity.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/Identity.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -22,5 +22,5 @@
  * something of a jabac extension.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class Identity implements Comparable {
Index: java/net/deterlab/abac/InternalCredential.java
===================================================================
--- java/net/deterlab/abac/InternalCredential.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/InternalCredential.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -20,5 +20,5 @@
  * should never be converted to a cert or output.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class InternalCredential extends Credential {
Index: java/net/deterlab/abac/MissingIssuerException.java
===================================================================
--- java/net/deterlab/abac/MissingIssuerException.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/MissingIssuerException.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -6,5 +6,5 @@
  * them when possible.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class MissingIssuerException extends ABACException  {
Index: java/net/deterlab/abac/Query.java
===================================================================
--- java/net/deterlab/abac/Query.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/Query.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -12,5 +12,5 @@
  * well as reachability in either direction. See the run method for details.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 class Query {
Index: java/net/deterlab/abac/Role.java
===================================================================
--- java/net/deterlab/abac/Role.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/Role.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -6,5 +6,5 @@
  * Represents a role, which is a vertex in a Credential graph.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class Role implements Comparable {
Index: java/net/deterlab/abac/X509Credential.java
===================================================================
--- java/net/deterlab/abac/X509Credential.java	(revision d06c4535092423fed3f8c8d33ced95e72bee95ad)
+++ java/net/deterlab/abac/X509Credential.java	(revision 4560b6544314aa54dc5fb0cdbe0a36ec1580c0f1)
@@ -21,5 +21,5 @@
  * their constituent Roles.
  * @author <a href="http://abac.deterlab.net">ISI ABAC team</a>
- * @version 1.3
+ * @version 1.4
  */
 public class X509Credential extends Credential implements Comparable {