Index: examples/acme_rockets_rt0_typed/README
===================================================================
--- examples/acme_rockets_rt0_typed/README	(revision 7727f26afdaff81acebfc2f0d5e4baef296aaf29)
+++ examples/acme_rockets_rt0_typed/README	(revision 9502c508ce06557e5b7c58a3f26b202bbe35e87b)
@@ -1,4 +1,4 @@
 #!/bin/sh
-
+#
 # The example makes use of 2 principals, Acme and Coyote.
 #
@@ -9,10 +9,10 @@
 # Credential 2 defines the Coyote as an Acme preferred customer.
 
-# The ./rr script issues queries to show that the Coyote is both a preferred
+# The ./run_query script issues queries to show that the Coyote is both a preferred
 # customer and can buy rockets.  Two invalid queries are also made, checking if
 # Acme is the Coyote's friend, which it isn't and whether a query about
 # something other than a principal works (it doesn't).
 
-rm -rf *.der *.pem
+# acme_rockets_rt0_typed
 
 creddy --generate --cn Acme
Index: examples/acme_rockets_rt0_typed/rr
===================================================================
--- examples/acme_rockets_rt0_typed/rr	(revision 7727f26afdaff81acebfc2f0d5e4baef296aaf29)
+++ 	(revision )
@@ -1,48 +1,0 @@
-
-rm -rf creds_dump
-
-pwd=`pwd`
-
-eloc=$pwd/../../libabac
-keyloc=$pwd
-
-acme=`creddy --keyid --cert $keyloc/Acme_ID.pem`
-coyote=`creddy --keyid --cert $keyloc/Coyote_ID.pem`
-
-preferred_customer="[keyid:$acme].role:preferred_customer"
-buy_rockets="[keyid:$acme].role:buy_rockets"
-coyote_prin="[keyid:$coyote]"
-friend="[keyid:$acme].role:friend"
-acme_prin="[keyid:$acme]"
-
-## dump all credentials
-$eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
-
-#[keyid:Acme].role:preferred_customer <-?- [keyid:Coyote] yap
-#isMember(pCoyote, role(pAcme,preferred_customer), C).
-echo "  "
-echo "===good============ Acme.preferred_customer <- Coyote yap "
-$eloc/abac_prover_yap  --keystore $keyloc \
-      --role "$preferred_customer" --principal "$coyote_prin"
-
-#[keyid:Acme].role:buy_rockets <-?- [keyid:Coyote] yap
-#isMember(pCoyote, role(pAcme,buy_rockets), C).
-echo "  "
-echo "===good=============== Acme.buy_rockets <- Coyote yap"
-$eloc/abac_prover_yap  --keystore $keyloc \
-        --role "$buy_rockets" --principal "$coyote_prin"
-
-## this is not suppose to work
-#[keyid:Acme].role:buy_rockets <-?- [keyid:Acme].role:preferred_customer yap
-echo "  "
-echo "===bad=============== Acme.buy_rockets <- Acme.preferred_customer yap"
-$eloc/abac_prover_yap  --keystore $keyloc \
-        --role "$buy_rockets" --principal "$preferred_customer"
-
-#[keyid:Coyote].role:friend <-?- [keyid:Acme] yap
-#isMember(pAcme, role(pCoyote,friend), C).
-echo "  "
-echo "===bad=============== Coyote.friend <- Acme yap"
-$eloc/abac_prover_yap  --keystore $keyloc \
-        --role "$friend" --principal "$acme_prin"
-
Index: examples/acme_rockets_rt0_typed/run_query
===================================================================
--- examples/acme_rockets_rt0_typed/run_query	(revision 9502c508ce06557e5b7c58a3f26b202bbe35e87b)
+++ examples/acme_rockets_rt0_typed/run_query	(revision 9502c508ce06557e5b7c58a3f26b202bbe35e87b)
@@ -0,0 +1,48 @@
+
+# acme_rockets_rt0_typed
+
+pwd=`pwd`
+
+eloc=$pwd/../../libabac
+keyloc=$pwd
+
+acme=`creddy --keyid --cert $keyloc/Acme_ID.pem`
+coyote=`creddy --keyid --cert $keyloc/Coyote_ID.pem`
+
+preferred_customer="[keyid:$acme].role:preferred_customer"
+buy_rockets="[keyid:$acme].role:buy_rockets"
+coyote_prin="[keyid:$coyote]"
+friend="[keyid:$acme].role:friend"
+acme_prin="[keyid:$acme]"
+
+## dump all credentials
+$eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
+
+#[keyid:Acme].role:preferred_customer <-?- [keyid:Coyote]
+#isMember(pCoyote, role(pAcme,preferred_customer), C).
+echo "  "
+echo "===good============ Acme.preferred_customer <- Coyote"
+$eloc/abac_prover_yap  --keystore $keyloc \
+      --role "$preferred_customer" --principal "$coyote_prin"
+
+#[keyid:Acme].role:buy_rockets <-?- [keyid:Coyote]
+#isMember(pCoyote, role(pAcme,buy_rockets), C).
+echo "  "
+echo "===good=============== Acme.buy_rockets <- Coyote"
+$eloc/abac_prover_yap  --keystore $keyloc \
+        --role "$buy_rockets" --principal "$coyote_prin"
+
+## this is not suppose to work
+#[keyid:Acme].role:buy_rockets <-?- [keyid:Acme].role:preferred_customer
+echo "  "
+echo "===bad=============== Acme.buy_rockets <- Acme.preferred_customer"
+$eloc/abac_prover_yap  --keystore $keyloc \
+        --role "$buy_rockets" --principal "$preferred_customer"
+
+#[keyid:Coyote].role:friend <-?- [keyid:Acme]
+#isMember(pAcme, role(pCoyote,friend), C).
+echo "  "
+echo "===bad=============== Coyote.friend <- Acme"
+$eloc/abac_prover_yap  --keystore $keyloc \
+        --role "$friend" --principal "$acme_prin"
+